Object.defineProperty(exports, "__esModule", {value: true});

/*body*/
var $1 = require('@livy/rotating-file-handler'/*$path$*/);
var $2 = require('@livy/line-formatter'/*$path$*/);
var $3 = require('../Driver'/*$path$*/);

class DailyDriver extends $3.Driver {
	
	
	/**
	@returns { string }
	*/
	get path(){
		var $4;
		
		let path = (($4 = this.options.path) != null) ? ($4) : 'storage/logs/formidable.log';
		
		if (path.includes('.')) {
			
			let args = path.split('.');
			
			const fileName = args.at(-2);
			
			args[args.length - 2] = ("" + fileName + "-%date%");
			
			path = args.join('.');
		} else {
			
			path = ("" + path + "-%date%");
		};
		
		return path;
	}
	
	handler(){
		
		return new $1.RotatingFileHandler(this.path,{
			formatter: new $2.LineFormatter({
				include: {
					datetime: true,
					channel: true,
					level: true,
					severity: false,
					message: true,
					context: true,
					extra: true
				},
				ignoreEmptyContext: true,
				ignoreEmptyExtra: true
			}),
			...this.options
		});
	}
};
exports.DailyDriver = DailyDriver;
