function contains$__(a,b){
	var res = (b && b.indexOf) ? b.indexOf(a) : [].indexOf.call(a,b);
	return res >= 0;
};;
function iter$__(a){ let v; return a ? ((v=a.toIterable) ? v.call(a) : a) : a; };
const $__init__$ = Symbol.for('#__init__'), $__patch__$ = Symbol.for('#__patch__'), $__initor__$ = Symbol.for('#__initor__'), $__inited__$ = Symbol.for('#__inited__'), $__hooks__$ = Symbol.for('#__hooks__');
var $7 = Symbol();
Object.defineProperty(exports, "__esModule", {value: true});

/*body*/
var $1 = require('@livy/util/lib/handlers/formattable-handler-mixin'/*$path$*/);
var $2 = require('@livy/contracts/lib/log-level'/*$path$*/);
var $3 = require('@livy/contracts/lib/log-record'/*$path$*/);
var $4 = require('@livy/line-formatter'/*$path$*/);
var $5 = require('@livy/util/lib/helpers'/*$path$*/);
var $6 = require('@livy/util/lib/types'/*$path$*/);

const COLOR_DANGER = 16711697;
const COLOR_WARNING = 16771898;
const COLOR_GOOD = 2135795;
const COLOR_DEFAULT = null;

const SeverityMap = {
	debug: 7,
	info: 6,
	notice: 5,
	warning: 4,
	error: 3,
	critical: 2,
	alert: 1,
	emergency: 0
};

class DiscordRecord extends $1.FormattableHandlerMixin(class Mixin {}) {
	static [$__init__$](){
		this.prototype[$__initor__$] = $7;
		return this;
	}
	[$__patch__$]($$ = {}){
		var $8;
		super[$__patch__$] && super[$__patch__$]($$);
		($8 = $$.username) !== undefined && (this.username = $8);
		($8 = $$.avatarUrl) !== undefined && (this.avatarUrl = $8);
		($8 = $$.useEmbed) !== undefined && (this.useEmbed = $8);
		($8 = $$.includeContextAndExtra) !== undefined && (this.includeContextAndExtra = $8);
		($8 = $$.excludedFields) !== undefined && (this.excludedFields = $8);
		
	}
	[$__init__$]($$ = null,deep = true){
		var $9;
		deep && super[$__init__$] && super[$__init__$](...arguments);
		this.username = ($$ && ($9 = $$.username) !== undefined) ? ($9) : null;
		this.avatarUrl = ($$ && ($9 = $$.avatarUrl) !== undefined) ? ($9) : null;
		this.useEmbed = $$ ? $$.useEmbed : undefined;
		this.includeContextAndExtra = $$ ? $$.includeContextAndExtra : undefined;
		this.excludedFields = ($$ && ($9 = $$.excludedFields) !== undefined) ? ($9) : [];
		
	}
	
	
	// Name of the bot
	
	
	// Profile picture of the bot
	
	
	// Whether the message should be added to Discord as embed (plain text otherwise)
	
	
	//  Whether the attachment should include context and extra data
	
	
	// Dot separated list of fields to exclude from slack message. E.g. ['context.field1', 'extra.field2']
	
	
	constructor(options = {}){
		
		super();
		
		super[$__init__$] || this[$__init__$]();
		this.username = options.username;
		this.useEmbed = (options.useEmbed !== false) ? true : options.useEmbed;
		this.avatarUrl = options.avatarUrl;
		this.includeContextAndExtra = (options.includeContextAndExtra !== undefined || options.includeContextAndExtra !== null) ? options.includeContextAndExtra : false;
		this.excludedFields = options.excludedFields || [];
		this.explicitFormatter = options.formatter;
		this[$__initor__$]===$7 && (this[$__hooks__$]&&this[$__hooks__$].inited(this),this[$__inited__$] && this[$__inited__$]());
	}
	
	// Get required data in format that Discord is expecting
	/**
	@param {LogRecord} record
	*/
	getDiscordData(record){
		
		const data = {};
		const clearedRecord = this.removeExcludedFields(record);
		
		data.content = null;
		
		const message = this.useEmbed ? clearedRecord.message : this.formatter.format(clearedRecord);
		
		if (this.username) {
			
			data.username = this.username;
		};
		
		if (this.useEmbed) {
			
			const embed = {
				title: "Message",
				description: message,
				color: this.getEmbedColor(clearedRecord.level),
				fields: [
					{
						name: "Level",
						value: clearedRecord.level
					}
				]
			};
			
			if (this.includeContextAndExtra) {
				
				for (let $10 = 0, $11 = ['context','extra'], $12 = $11.length; $10 < $12; $10++) {
					let key = $11[$10];
					if ($5.isEmpty(clearedRecord[key])) {
						
						continue;
					};
					
					embed.fields.push(...this.generateEmbedFields(clearedRecord[key]));
				};
			};
			
			data.embeds = [embed];
		} else {
			
			data.content = message;
		};
		
		if (this.avatarUrl) {
			
			data.avatar_url = this.avatarUrl;
		};
		
		return data;
	}
	
	// Get a Discord message embed color associated with the provided level
	/**
	@param {LogLevel} level
	@returns { number }
	*/
	getEmbedColor(level){
		
		const severity = SeverityMap[level];
		
		switch (true) {
			case severity <= SeverityMap.error: {
				
				return COLOR_DANGER;
				break;
			}
			case severity <= SeverityMap.warning: {
				
				return COLOR_WARNING;
				break;
			}
			case severity <= SeverityMap.info: {
				
				return COLOR_GOOD;
				break;
			}
			default:
			
				
				return COLOR_DEFAULT;
		
		};
	}
	
	// Stringify an array of key/value pairs to be used in embed fields
	/**
	@param {AnyObject|any[]} fields
	*/
	stringify(fields){
		
		const isObject = !(Array.isArray(fields));
		const hasNestedData = !(Array.isArray(fields)) || this.field.some(function(field) { return typeof field === 'object' && field !== null; });
		
		return (isObject || hasNestedData) ? JSON.stringify(fields,null,2) : JSON.stringify(fields);
	}
	
	// @inheritdoc
	getDefaultFormatter(){
		
		return new $4.LineFormatter({
			include: {
				context: this.includeContextAndExtra,
				extra: this.includeContextAndExtra
			}
		});
	}
	
	// Generate an attachment field
	/**
	@param {string} title
	@param {string|number|AnyObject|any} value
	*/
	generateEmbedField(title,value){
		
		const stringifiedValue = (typeof value === 'string' || typeof value === 'number') ? String(value) : ('```json\n' + this.stringify(value) + '\n```');
		
		return {
			name: $5.capitalizeFirstLetter(title),
			value: stringifiedValue
		};
	}
	
	// Generate a collection of embed fields
	/**
	@param {Partial<LogRecord>} data
	*/
	generateEmbedFields(data){
		var self = this;
		
		return Object.entries(data).map(function([key,value]) {
			
			return self.generateEmbedField(key,value);
		});
	}
	
	// Get a copy of record with fields excluded according to `self.excludedFields`
	/**
	@param {LogRecord} record
	*/
	removeExcludedFields(record){
		var $17;
		
		const copy = {...record};
		
		for (let $13 = 0, $14 = iter$__(this.excludedFields), $19 = $14.length; $13 < $19; $13++) {
			let field = $14[$13];
			const keys = field.split('.');
			let node = copy;
			const lastKey = keys[keys.length - 1];
			
			for (let $15 = 0, $16 = iter$__(keys), $18 = $16.length; $15 < $18; $15++) {
				let key = $16[$15];
				if (!(contains$__(key,node))) {
					
					break;
				};
				
				if (lastKey === key) {
					
					((($17 = node[key]),delete node[key], $17));
					break;
				};
				
				node = node[key];
			};
		};
		
		return copy;
	}
};
exports.DiscordRecord = DiscordRecord; DiscordRecord[$__init__$]();
